searchData={"items":[{"type":"module","title":"Result","doc":"Documentation for Result.","ref":"Result.html"},{"type":"macro","title":"Result.and_then/2","doc":"See `Result.Operators.and_then/2`","ref":"Result.html#and_then/2"},{"type":"macro","title":"Result.and_then_x/2","doc":"See `Result.Operators.and_then_x/2`","ref":"Result.html#and_then_x/2"},{"type":"macro","title":"Result.catch_all_errors/2","doc":"See `Result.Operators.catch_all_errors/2`","ref":"Result.html#catch_all_errors/2"},{"type":"macro","title":"Result.catch_error/3","doc":"See `Result.Operators.catch_error/3`","ref":"Result.html#catch_error/3"},{"type":"macro","title":"Result.error/1","doc":"See `Result.Error.of/1`","ref":"Result.html#error/1"},{"type":"macro","title":"Result.error?/1","doc":"See `Result.Operators.error?/1`","ref":"Result.html#error?/1"},{"type":"macro","title":"Result.fold/1","doc":"See `Result.Operators.fold/1`","ref":"Result.html#fold/1"},{"type":"macro","title":"Result.from/2","doc":"See `Result.Operators.from/2`","ref":"Result.html#from/2"},{"type":"macro","title":"Result.map2/3","doc":"See `Result.Operators.map2/3`","ref":"Result.html#map2/3"},{"type":"macro","title":"Result.map/2","doc":"See `Result.Operators.map/2`","ref":"Result.html#map/2"},{"type":"macro","title":"Result.map_error/2","doc":"See `Result.Operators.map_error/2`","ref":"Result.html#map_error/2"},{"type":"macro","title":"Result.ok/1","doc":"See `Result.Ok.of/1`","ref":"Result.html#ok/1"},{"type":"macro","title":"Result.ok?/1","doc":"See `Result.Operators.ok?/1`","ref":"Result.html#ok?/1"},{"type":"macro","title":"Result.perform/2","doc":"See `Result.Operators.perform/2`","ref":"Result.html#perform/2"},{"type":"macro","title":"Result.product/1","doc":"See `Result.Calc.product/1`","ref":"Result.html#product/1"},{"type":"macro","title":"Result.r_and/2","doc":"See `Result.Calc.r_and/2`","ref":"Result.html#r_and/2"},{"type":"macro","title":"Result.r_or/2","doc":"See `Result.Calc.r_or/2`","ref":"Result.html#r_or/2"},{"type":"macro","title":"Result.resolve/1","doc":"See `Result.Operators.resolve/1`","ref":"Result.html#resolve/1"},{"type":"macro","title":"Result.retry/4","doc":"See `Result.Operators.retry/4`","ref":"Result.html#retry/4"},{"type":"macro","title":"Result.sum/1","doc":"See `Result.Calc.sum/1`","ref":"Result.html#sum/1"},{"type":"macro","title":"Result.with_default/2","doc":"See `Result.Operators.with_default/2`","ref":"Result.html#with_default/2"},{"type":"type","title":"Result.t/2","doc":"","ref":"Result.html#t:t/2"},{"type":"module","title":"Result.Calc","doc":"Result calculations","ref":"Result.Calc.html"},{"type":"macro","title":"Result.Calc.product/1","doc":"Calculate product of Results\n\nproduct :: List (Result e a) -> Result (List e) (List a)","ref":"Result.Calc.html#product/1"},{"type":"macro","title":"Examples - Result.Calc.product/1","doc":"iex> data = [{:ok, 1}, {:ok, 2}, {:ok, 3}]\n    iex> Result.Calc.product(data)\n    {:ok, [1, 2, 3]}\n\n    iex> data = [{:error, 1}, {:ok, 2}, {:error, 3}]\n    iex> Result.Calc.product(data)\n    {:error, [1, 3]}\n\n    iex> data = [{:error, 1}]\n    iex> Result.Calc.product(data)\n    {:error, [1]}\n\n    iex> data = []\n    iex> Result.Calc.product(data)\n    {:ok, []}","ref":"Result.Calc.html#product/1-examples"},{"type":"macro","title":"Result.Calc.r_and/2","doc":"Calculate the AND of two results\n\nr_and :: Result e1 a -> Result e2 b -> Result [e1, e2] [a, b]","ref":"Result.Calc.html#r_and/2"},{"type":"macro","title":"Examples - Result.Calc.r_and/2","doc":"iex> Result.Calc.r_and({:ok, 1}, {:ok, 2})\n    {:ok, [1, 2]}\n\n    iex> Result.Calc.r_and({:ok, 1}, {:error, 2})\n    {:error, [2]}\n\n    iex> Result.Calc.r_and({:error, 1}, {:ok, 2})\n    {:error, [1]}\n\n    iex> Result.Calc.r_and({:error, 1}, {:error, 2})\n    {:error, [1, 2]}","ref":"Result.Calc.html#r_and/2-examples"},{"type":"macro","title":"Result.Calc.r_or/2","doc":"Calculate the OR of two results\n\nr_or :: Result e1 a -> Result e2 b -> Result [e1, e2] [a, b]","ref":"Result.Calc.html#r_or/2"},{"type":"macro","title":"Examples - Result.Calc.r_or/2","doc":"iex> Result.Calc.r_or({:ok, 1}, {:ok, 2})\n    {:ok, [1, 2]}\n\n    iex> Result.Calc.r_or({:ok, 1}, {:error, 2})\n    {:ok, [1]}\n\n    iex> Result.Calc.r_or({:error, 1}, {:ok, 2})\n    {:ok, [2]}\n\n    iex> Result.Calc.r_or({:error, 1}, {:error, 2})\n    {:error, [1, 2]}","ref":"Result.Calc.html#r_or/2-examples"},{"type":"macro","title":"Result.Calc.sum/1","doc":"Calculate sum of Results\n\nsum :: List (Result e a) -> Result (List e) (List a)","ref":"Result.Calc.html#sum/1"},{"type":"macro","title":"Examples - Result.Calc.sum/1","doc":"iex> data = [{:ok, 1}, {:ok, 2}, {:ok, 3}]\n    iex> Result.Calc.sum(data)\n    {:ok, [1, 2, 3]}\n\n    iex> data = [{:error, 1}, {:ok, 2}, {:error, 3}]\n    iex> Result.Calc.sum(data)\n    {:ok, [2]}\n\n    iex> data = [{:error, 1}, {:error, 2}, {:error, 3}]\n    iex> Result.Calc.sum(data)\n    {:error, [1, 2, 3]}\n\n    iex> data = [{:error, 1}]\n    iex> Result.Calc.sum(data)\n    {:error, [1]}\n\n    iex> data = []\n    iex> Result.Calc.sum(data)\n    {:error, []}","ref":"Result.Calc.html#sum/1-examples"},{"type":"module","title":"Result.Error","doc":"A Error creator","ref":"Result.Error.html"},{"type":"macro","title":"Result.Error.of/1","doc":"Create Error result from value","ref":"Result.Error.html#of/1"},{"type":"macro","title":"Examples - Result.Error.of/1","doc":"iex> Result.Error.of(\"a\")\n    {:error, \"a\"}\n\n    iex> Result.Error.of(12345)\n    {:error, 12345}","ref":"Result.Error.html#of/1-examples"},{"type":"type","title":"Result.Error.t/1","doc":"","ref":"Result.Error.html#t:t/1"},{"type":"module","title":"Result.Ok","doc":"A Ok creator","ref":"Result.Ok.html"},{"type":"macro","title":"Result.Ok.of/1","doc":"Create Ok result from value","ref":"Result.Ok.html#of/1"},{"type":"macro","title":"Examples - Result.Ok.of/1","doc":"iex> Result.Ok.of(\"a\")\n    {:ok, \"a\"}\n\n    iex> Result.Ok.of(12345)\n    {:ok, 12345}","ref":"Result.Ok.html#of/1-examples"},{"type":"type","title":"Result.Ok.t/1","doc":"","ref":"Result.Ok.html#t:t/1"},{"type":"module","title":"Result.Operators","doc":"A result operators.","ref":"Result.Operators.html"},{"type":"macro","title":"Result.Operators.and_then/2","doc":"Chain together a sequence of computations that may fail.","ref":"Result.Operators.html#and_then/2"},{"type":"macro","title":"Examples - Result.Operators.and_then/2","doc":"iex> val = {:ok, 1}\n    iex> Result.Operators.and_then(val, fn (x) -> {:ok, x + 1} end)\n    {:ok, 2}\n\n    iex> val = {:error, 1}\n    iex> Result.Operators.and_then(val, fn (x) -> {:ok, x + 1} end)\n    {:error, 1}","ref":"Result.Operators.html#and_then/2-examples"},{"type":"macro","title":"Result.Operators.and_then_x/2","doc":"Chain together a sequence of computations that may fail for functions with multiple argumets.","ref":"Result.Operators.html#and_then_x/2"},{"type":"macro","title":"Examples - Result.Operators.and_then_x/2","doc":"iex> args = [{:ok, 1}, {:ok, 2}]\n    iex> Result.Operators.and_then_x(args, fn (x, y) -> {:ok, x + y} end)\n    {:ok, 3}\n\n    iex> args = [{:ok, 1}, {:error, \"ERROR\"}]\n    iex> Result.Operators.and_then_x(args, fn (x, y) -> {:ok, x + y} end)\n    {:error, \"ERROR\"}","ref":"Result.Operators.html#and_then_x/2-examples"},{"type":"macro","title":"Result.Operators.catch_all_errors/2","doc":"Catch all errors and call function `f` with it.\n#","ref":"Result.Operators.html#catch_all_errors/2"},{"type":"macro","title":"Examples - Result.Operators.catch_all_errors/2","doc":"iex> error = {:error, :foo}\n    iex> Result.Operators.catch_all_errors(error, fn err -> {:ok, Atom.to_string(err)} end)\n    {:ok, \"foo\"}\n\n    iex> error = {:error, :bar}\n    iex> Result.Operators.catch_all_errors(error, fn err -> {:ok, Atom.to_string(err)} end)\n    {:ok, \"bar\"}\n\n    iex> ok = {:ok, 3}\n    iex> Result.Operators.catch_all_errors(ok, fn err -> {:ok, Atom.to_string(err)} end)\n    {:ok, 3}","ref":"Result.Operators.html#catch_all_errors/2-examples"},{"type":"macro","title":"Result.Operators.catch_error/3","doc":"Catch specific error `expected_error` and call function `f` with it.\nOthers errors or oks pass untouched.","ref":"Result.Operators.html#catch_error/3"},{"type":"macro","title":"Examples - Result.Operators.catch_error/3","doc":"iex> error = {:error, :foo}\n    iex> Result.Operators.catch_error(error, :foo, fn _ -> {:ok, \"FOO\"} end)\n    {:ok, \"FOO\"}\n\n    iex> error = {:error, :bar}\n    iex> Result.Operators.catch_error(error, :foo, fn _ -> {:ok, \"FOO\"} end)\n    {:error, :bar}\n\n    iex> ok = {:ok, 3}\n    iex> Result.Operators.catch_error(ok, :foo,  fn _ -> {:ok, \"FOO\"} end)\n    {:ok, 3}","ref":"Result.Operators.html#catch_error/3-examples"},{"type":"macro","title":"Result.Operators.error?/1","doc":"Return `true` if result is error","ref":"Result.Operators.html#error?/1"},{"type":"macro","title":"Examples - Result.Operators.error?/1","doc":"iex> Result.Operators.error?({:error, 123})\n    true\n\n    iex> Result.Operators.error?({:ok, 123})\n    false","ref":"Result.Operators.html#error?/1-examples"},{"type":"macro","title":"Result.Operators.fold/1","doc":"Fold function returns tuple `{:ok, [...]}` if all\ntuples in list contain `:ok` or `{:error, ...}` if\nonly one tuple contains `:error`.","ref":"Result.Operators.html#fold/1"},{"type":"macro","title":"Examples - Result.Operators.fold/1","doc":"iex> val = [{:ok, 3}, {:ok, 5}, {:ok, 12}]\n    iex> Result.Operators.fold(val)\n    {:ok, [3, 5, 12]}\n\n    iex> val = [{:ok, 3}, {:error, 1}, {:ok, 2}, {:error, 2}]\n    iex> Result.Operators.fold(val)\n    {:error, 1}","ref":"Result.Operators.html#fold/1-examples"},{"type":"macro","title":"Result.Operators.from/2","doc":"Convert maybe to result type.","ref":"Result.Operators.html#from/2"},{"type":"macro","title":"Examples - Result.Operators.from/2","doc":"iex> Result.Operators.from(123, \"msg\")\n    {:ok, 123}\n\n    iex> Result.Operators.from(nil, \"msg\")\n    {:error, \"msg\"}\n\n    iex> Result.Operators.from(:ok, 123)\n    {:ok, 123}\n\n    iex> Result.Operators.from(:error, 456)\n    {:error, 456}\n\n    iex> Result.Operators.from({:ok, 123}, \"value\")\n    {:ok, 123}\n\n    iex> Result.Operators.from({:error, \"msg\"}, \"value\")\n    {:error, \"msg\"}","ref":"Result.Operators.html#from/2-examples"},{"type":"macro","title":"Result.Operators.map2/3","doc":"Apply a function if both results are Ok. If not, the first Err will propagate through.","ref":"Result.Operators.html#map2/3"},{"type":"macro","title":"Examples - Result.Operators.map2/3","doc":"iex> Result.Operators.map2({:ok, 1}, {:ok, 2}, fn(x, y) -> x + y end)\n    {:ok, 3}\n\n    iex> Result.Operators.map2({:ok, 1}, {:error, 2}, fn(x, y) -> x + y end)\n    {:error, 2}\n\n    iex> Result.Operators.map2({:error, 1}, {:error, 2}, fn(x, y) -> x + y end)\n    {:error, 1}","ref":"Result.Operators.html#map2/3-examples"},{"type":"macro","title":"Result.Operators.map/2","doc":"Apply a function `f` to `value` if result is Ok.","ref":"Result.Operators.html#map/2"},{"type":"macro","title":"Examples - Result.Operators.map/2","doc":"iex> ok = {:ok, 3}\n    iex> Result.Operators.map(ok, fn(x) -> x + 10 end)\n    {:ok, 13}\n\n    iex> error = {:error, 3}\n    iex> Result.Operators.map(error, fn(x) -> x + 10 end)\n    {:error, 3}","ref":"Result.Operators.html#map/2-examples"},{"type":"macro","title":"Result.Operators.map_error/2","doc":"Apply a function `f` to `value` if result is Error.\n\nTransform an Error value. For example, say the errors we get have too much information","ref":"Result.Operators.html#map_error/2"},{"type":"macro","title":"Examples - Result.Operators.map_error/2","doc":"iex> error = {:error, %{msg: \"ERROR\", status: 4321}}\n    iex> Result.Operators.map_error(error, &(&1.msg))\n    {:error, \"ERROR\"}\n\n    iex> ok = {:ok, 3}\n    iex> Result.Operators.map_error(ok, fn(x) -> x + 10 end)\n    {:ok, 3}","ref":"Result.Operators.html#map_error/2-examples"},{"type":"macro","title":"Result.Operators.ok?/1","doc":"Return `true` if result is ok","ref":"Result.Operators.html#ok?/1"},{"type":"macro","title":"Examples - Result.Operators.ok?/1","doc":"iex> Result.Operators.ok?({:ok, 123})\n    true\n\n    iex> Result.Operators.ok?({:error, 123})\n    false","ref":"Result.Operators.html#ok?/1-examples"},{"type":"macro","title":"Result.Operators.perform/2","doc":"Perform function `f` on Ok result and return it","ref":"Result.Operators.html#perform/2"},{"type":"macro","title":"Examples - Result.Operators.perform/2","doc":"iex> Result.Operators.perform({:ok, 123}, fn(x) -> x * 100 end)\n    {:ok, 123}\n\n    iex> Result.Operators.perform({:error, 123}, fn(x) -> IO.puts(x) end)\n    {:error, 123}","ref":"Result.Operators.html#perform/2-examples"},{"type":"macro","title":"Result.Operators.resolve/1","doc":"Flatten nested results\n\nresolve :: Result x (Result x a) -> Result x a","ref":"Result.Operators.html#resolve/1"},{"type":"macro","title":"Examples - Result.Operators.resolve/1","doc":"iex> Result.Operators.resolve({:ok, {:ok, 1}})\n    {:ok, 1}\n\n    iex> Result.Operators.resolve({:ok, {:error, \"one\"}})\n    {:error, \"one\"}\n\n    iex> Result.Operators.resolve({:error, \"two\"})\n    {:error, \"two\"}","ref":"Result.Operators.html#resolve/1-examples"},{"type":"macro","title":"Result.Operators.retry/4","doc":"Retry `count` times the function `f` if the result is negative\n\nretry :: Result err a -> (a -> Result err b) -> Int -> Int -> Result err b\n\n* `res` - input result\n* `f` - function retruns result\n* `count` - try count\n* `timeout` - timeout between retries","ref":"Result.Operators.html#retry/4"},{"type":"macro","title":"Examples - Result.Operators.retry/4","doc":"iex> Result.Operators.retry({:error, \"Error\"}, fn(x) -> {:ok, x} end, 3)\n    {:error, \"Error\"}\n\n    iex> Result.Operators.retry({:ok, \"Ok\"}, fn(x) -> {:ok, x} end, 3)\n    {:ok, \"Ok\"}\n\n    iex> Result.Operators.retry({:ok, \"Ok\"}, fn(_) -> {:error, \"Error\"} end, 3, 0)\n    {:error, \"Error\"}","ref":"Result.Operators.html#retry/4-examples"},{"type":"macro","title":"Result.Operators.with_default/2","doc":"Return `value` if result is ok, otherwise `default`","ref":"Result.Operators.html#with_default/2"},{"type":"macro","title":"Examples - Result.Operators.with_default/2","doc":"iex> Result.Operators.with_default({:ok, 123}, 456)\n    123\n\n    iex> Result.Operators.with_default({:error, 123}, 456)\n    456","ref":"Result.Operators.html#with_default/2-examples"},{"type":"module","title":"Result.Utils","doc":"A result utility functions","ref":"Result.Utils.html"},{"type":"macro","title":"Result.Utils.check/1","doc":"","ref":"Result.Utils.html#check/1"},{"type":"exception","title":"Result.TypeError","doc":"","ref":"Result.TypeError.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}